## mingw-w64-badvpn-1.999.130-4.src.tar.zst

=== arpprobe/CMakeLists.txt ===
badvpn_add_library(arpprobe "base;system;flow" "" BArpProbe.c)

=== base/CMakeLists.txt ===
set(BASE_ADDITIONAL_SOURCES)

if (HAVE_SYSLOG_H)
    list(APPEND BASE_ADDITIONAL_SOURCES BLog_syslog.c)
endif ()

set(BASE_SOURCES
    DebugObject.c
    BLog.c
    BPending.c
    ${BASE_ADDITIONAL_SOURCES}
)
badvpn_add_library(base "" "" "${BASE_SOURCES}")

=== dhcpclient/CMakeLists.txt ===
badvpn_add_library(dhcpclientcore "system;flow;flowextra;badvpn_random" "" BDHCPClientCore.c)

if (CMAKE_SYSTEM_NAME STREQUAL "Linux")
    set(DHCPCLIENT_SOURCES
        BDHCPClient.c
        DHCPIpUdpEncoder.c
        DHCPIpUdpDecoder.c
    )
    badvpn_add_library(dhcpclient "system;flow;dhcpclientcore" "" "${DHCPCLIENT_SOURCES}")
endif ()

=== examples/CMakeLists.txt ===
if (NOT EMSCRIPTEN)
    add_executable(btimer_example btimer_example.c)
    target_link_libraries(btimer_example system)
endif ()

if (BUILDING_PREDICATE)
    add_executable(predicate_test predicate_test.c)
    target_link_libraries(predicate_test predicate)
endif ()

if (NOT EMSCRIPTEN)
    add_executable(fairqueue_test fairqueue_test.c)
    target_link_libraries(fairqueue_test system flow)
endif ()

add_executable(indexedlist_test indexedlist_test.c)

if (BUILDING_SECURITY)
    add_executable(fairqueue_test2 fairqueue_test2.c)
    target_link_libraries(fairqueue_test2 system flow security)

    add_executable(bavl_test bavl_test.c)
    target_link_libraries(bavl_test security)

    add_executable(savl_test savl_test.c)
    target_link_libraries(savl_test security)

    add_executable(bencryption_bench bencryption_bench.c)
    target_link_libraries(bencryption_bench system security)
endif ()

if (BUILD_NCD)
    add_executable(ncd_tokenizer_test ncd_tokenizer_test.c)
    target_link_libraries(ncd_tokenizer_test ncdtokenizer)

    add_executable(ncd_parser_test ncd_parser_test.c)
    target_link_libraries(ncd_parser_test ncdconfigparser ncdvalgenerator ncdsugar)

    add_executable(ncd_value_parser_test ncd_value_parser_test.c)
    target_link_libraries(ncd_value_parser_test ncdvalparser ncdvalgenerator)

    if (NOT EMSCRIPTEN)
        add_executable(ncdinterfacemonitor_test ncdinterfacemonitor_test.c)
        target_link_libraries(ncdinterfacemonitor_test ncdinterfacemonitor)
    endif ()

    add_executable(ncdval_test ncdval_test.c)
    target_link_libraries(ncdval_test ncdval)
    
    add_executable(ncdvalcons_test ncdvalcons_test.c)
    target_link_libraries(ncdvalcons_test ncdvalcons ncdvalgenerator)
endif ()

if (BUILDING_UDEVMONITOR)
    add_executable(ncdudevmonitor_test ncdudevmonitor_test.c)
    target_link_libraries(ncdudevmonitor_test udevmonitor)

    add_executable(ncdudevmanager_test ncdudevmanager_test.c)
    target_link_libraries(ncdudevmanager_test udevmonitor)
endif ()

if (NOT WIN32 AND NOT EMSCRIPTEN)
    add_executable(bprocess_example bprocess_example.c)
    target_link_libraries(bprocess_example system)

    add_executable(stdin_input stdin_input.c)
    target_link_libraries(stdin_input system flow flowextra)
endif ()

if (BUILDING_DHCPCLIENT)
    add_executable(dhcpclient_test dhcpclient_test.c)
    target_link_libraries(dhcpclient_test dhcpclient)
endif ()

if (BUILDING_ARPPROBE)
    add_executable(arpprobe_test arpprobe_test.c)
    target_link_libraries(arpprobe_test arpprobe)
endif ()

add_executable(substring_test substring_test.c)

if (NOT WIN32)
    add_executable(ipaddr6_test ipaddr6_test.c)
    add_executable(parse_number_test parse_number_test.c)
endif ()

if (BUILDING_RANDOM)
    add_executable(brandom2_test brandom2_test.c)
    target_link_libraries(brandom2_test badvpn_random)
endif ()

add_executable(cavl_test cavl_test.c)

if (EMSCRIPTEN)
    add_executable(emscripten_test emscripten_test.c)
    target_link_libraries(emscripten_test system)
endif ()

=== flow/CMakeLists.txt ===
set(FLOW_SOURCES
    PacketPassFairQueue.c
    PacketPassPriorityQueue.c
    PacketPassConnector.c
    PacketRecvConnector.c
    StreamRecvConnector.c
    PacketRecvBlocker.c
    PacketPassNotifier.c
    PacketBuffer.c
    SinglePacketBuffer.c
    PacketCopier.c
    PacketStreamSender.c
    PacketProtoEncoder.c
    PacketProtoDecoder.c
    PacketProtoFlow.c
    SinglePacketSender.c
    BufferWriter.c
    PacketPassInterface.c
    PacketRecvInterface.c
    StreamPassInterface.c
    StreamRecvInterface.c
    RouteBuffer.c
    PacketRouter.c
    LineBuffer.c
    SingleStreamSender.c
    SingleStreamReceiver.c
    StreamPacketSender.c
    StreamPassConnector.c
    PacketPassFifoQueue.c
)
badvpn_add_library(flow "base" "" "${FLOW_SOURCES}")

=== ncd-request/CMakeLists.txt ===
add_executable(badvpn-ncd-request
    ncd-request.c
)
target_link_libraries(badvpn-ncd-request ncdrequest ncdvalgenerator ncdvalparser)

install(
    TARGETS badvpn-ncd-request
    RUNTIME DESTINATION bin
)

=== nspr_support/CMakeLists.txt ===
set(NSPRSUPPORT_SOURCES
    DummyPRFileDesc.c
    BSSLConnection.c
)
badvpn_add_library(nspr_support "system;flow;threadwork" "${NSPR_LIBRARIES};${NSS_LIBRARIES}" "${NSPRSUPPORT_SOURCES}")

=== socksclient/CMakeLists.txt ===
badvpn_add_library(socksclient "system;flow;flowextra" "" BSocksClient.c)

=== tests/CMakeLists.txt ===
add_executable(chunkbuffer2_test chunkbuffer2_test.c)

add_executable(bproto_test bproto_test.c)

if (BUILDING_THREADWORK)
    add_executable(threadwork_test threadwork_test.c)
    target_link_libraries(threadwork_test threadwork)
endif ()

=== udevmonitor/CMakeLists.txt ===
set(UDEVMONITOR_SOURCES
    NCDUdevMonitorParser.c
    NCDUdevMonitor.c
    NCDUdevCache.c
    NCDUdevManager.c
)
badvpn_add_library(udevmonitor "system;flow;stringmap" "" "${UDEVMONITOR_SOURCES}")

=== udpgw_client/CMakeLists.txt ===
badvpn_add_library(udpgw_client "system;flow;flowextra" "" UdpGwClient.c)

=== PKGBUILD ===
# Maintainer: David Macek <david.macek.0@gmail.com>

# todo -DBUILD_SHARED_LIBS=ON
_realname=badvpn
pkgbase=mingw-w64-${_realname}
pkgname="${MINGW_PACKAGE_PREFIX}-${_realname}"
pkgver=1.999.130
pkgrel=4
pkgdesc="NCD scripting language, tun2socks proxifier, P2P VPN (mingw-w64)"
arch=('any')
mingw_arch=('mingw32' 'mingw64' 'ucrt64' 'clang64' 'clang32')
url="https://github.com/ambrop72/badvpn"
license=('BSD')
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja")
depends=("${MINGW_PACKAGE_PREFIX}-glib2"
         "${MINGW_PACKAGE_PREFIX}-nspr"
         "${MINGW_PACKAGE_PREFIX}-nss"
         "${MINGW_PACKAGE_PREFIX}-openssl")
source=("${_realname}-${pkgver}.tar.gz"::"https://github.com/ambrop72/badvpn/archive/${pkgver}.tar.gz")
sha256sums=('bfd4bbfebd7274bcec792558c9a2fd60e39cd92e04673825ade5d04154766109')

build() {
  mkdir -p "${srcdir}"/build-${MSYSTEM} && cd "${srcdir}"/build-${MSYSTEM}

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  ${MINGW_PREFIX}/bin/cmake \
    -G "Ninja" \
    -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
    -DCMAKE_BUILD_TYPE=Release \
    -DCMAKE_INCLUDE_PATH="${MINGW_PREFIX}/include/nspr:${MINGW_PREFIX}/include/nss3" \
    -DBUILD_EXAMPLES=OFF \
    -DBUILD_TESTS=OFF \
    ../${_realname}-${pkgver}

  ${MINGW_PREFIX}/bin/cmake --build .
}

package() {
  cd "${srcdir}"/build-${MSYSTEM}
  DESTDIR=${pkgdir} ${MINGW_PREFIX}/bin/cmake --install .
  install -Dm644 "${srcdir}"/${_realname}-${pkgver}/COPYING "${pkgdir}"${MINGW_PREFIX}/share/licenses/${_realname}/COPYING
}
